
## remove (almost) everything in the working environment.
rm(list = ls())


# to import xl files
library(readxl)
#to write excel files
require(writexl)
# to output towards latex
require(stargazer)


setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\base")


#=========================================================================================

#load database of families
families <- as.data.frame(read_excel("Families.xlsx"))
nfamil<-nrow(families)

#Opening the dictionary containing notoriety metrics for each individual
basew <- as.data.frame(read_excel("Dictionary.xlsx"))


#Opening the base containing other infos for each individual
bigbase <- as.data.frame(read_excel("Profs.xlsx"))
bigbase$refdatel <- pmin(bigbase$Beginning,bigbase$DateApprox,
         bigbase$YearBorn+30,bigbase$End,bigbase$YearDied,na.rm=T)

#bigbase <- bigbase[!is.na(bigbase$refdatel),]

#Opening the base containing other infos for each institution
institutions <- as.data.frame(read_excel("Institutions-All.xlsx"))


#moving to the output directory
setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\database")


#compute number of families by institution in a new dataframe
ilist=unique(families$IKey)
instit <- data.frame("IKey" = ilist, "Nb" = 0 ,"Youngest" =0,"Oldest"=0,"Univ"=0,"Cov"=0)
for (i in ilist){
instit[instit$IKey==i,"Nb"] <- nrow(families[families$IKey==i,])
instit[instit$IKey==i,"Univ"] <- institutions[institutions$IKey==i,"University"]
instit[instit$IKey==i,"Cov"] <- ifelse(institutions[institutions$IKey==i,"CovComprehensive"]==T ,3 ,
ifelse(institutions[institutions$IKey==i,"CovBroad"]==T ,2 ,
ifelse(institutions[institutions$IKey==i,"CovPartial"]==T ,1 ,0 ) ) )
}

#here we change the assumption: no page wc implies zero publications (not one as in the database)
basew$nworks <- ifelse(basew$pagewc==1,basew$nworks,0)
basew$nlib <- ifelse(basew$pagewc==1,basew$nlib,0)
basew$publi_by <- ifelse(basew$pagewc==1,basew$publi_by,0)

families$Sworks <- 0  #number of works by the son
families$Fworks <- 0  #number of works by the father
families$Sin <- 0  #whether son is in WC
families$Fin <- 0  #whether father is in WC


#collect data from the dictionary
# the data cropped from worldcat include:
#nworks	publications	publi_by	publi_about	nlang	nlib

for (i in 1:nfamil)
{
families[i,"Sworks"] <-  as.numeric(basew[basew$PKey==families[i,"Son"],"nworks"]) 
families[i,"Fworks"] <-  as.numeric(basew[basew$PKey==families[i,"Father"],"nworks"])
families[i,"Spubby"] <-  as.numeric(basew[basew$PKey==families[i,"Son"],"publi_by"]) 
families[i,"Fpubby"] <-  as.numeric(basew[basew$PKey==families[i,"Father"],"publi_by"])
families[i,"Slibh"] <-  as.numeric(basew[basew$PKey==families[i,"Son"],"nlib"]) 
families[i,"Flibh"] <-  as.numeric(basew[basew$PKey==families[i,"Father"],"nlib"])
families[i,"Sin"] <-  as.numeric(basew[basew$PKey==families[i,"Son"],"pagewc"]) 
families[i,"Fin"] <-  as.numeric(basew[basew$PKey==families[i,"Father"],"pagewc"])
families[i,"Sinwiki"] <-  as.numeric(basew[basew$PKey==families[i,"Son"],"pagewiki"]) 
families[i,"Finwiki"] <-  as.numeric(basew[basew$PKey==families[i,"Father"],"pagewiki"])
families[i,"Sinwc"] <-  as.numeric(basew[basew$PKey==families[i,"Son"],"pagewc"]) 
families[i,"Finwc"] <-  as.numeric(basew[basew$PKey==families[i,"Father"],"pagewc"])
}


families$Sdate <- 0  # reference date for the son (when he enters the population of scholars)
families$Fdate <- 0  #reference date for the father

#collect data from the dictionary
for (i in 1:nfamil)
{
tpson <- bigbase[bigbase$PKey==families[i,"Son"],]
tpfather<-bigbase[bigbase$PKey==families[i,"Father"],]
families[i,"Sdate"] <-  min(tpson$refdatel) 
families[i,"Fdate"] <-  min(tpfather$refdatel)
families[i,"Sdied"] <-  ifelse(is.na(min(tpson$YearDied,na.rm=T)), NA, min(tpson$YearDied))
families[i,"Fdied"] <-  ifelse(is.na(min(tpfather$YearDied,na.rm=T)), NA, min(tpfather$YearDied))
families[i,"Sborn"] <-  ifelse(is.na(min(tpson$YearBorn,na.rm=T)), NA, min(tpson$YearBorn))
families[i,"Fborn"] <-  ifelse(is.na(min(tpfather$YearBorn,na.rm=T)), NA, min(tpfather$YearBorn))
}

#collect other data
for (i in 1:nfamil)
{
families[i,"Sstart"] <-  min(bigbase[bigbase$PKey==families[i,"Son"] & bigbase$IKey==families[i,"IKey"],"Beginning"])
families[i,"Fstart"] <-  min(bigbase[bigbase$PKey==families[i,"Father"] & bigbase$IKey==families[i,"IKey"],"Beginning"])
families[i,"Field1"] <-  min(bigbase[bigbase$PKey==families[i,"Father"] & bigbase$IKey==families[i,"IKey"],"Field"])
families[i,"Field2"] <-  min(bigbase[bigbase$PKey==families[i,"Father"] & bigbase$IKey==families[i,"IKey"],"Field2"])
families[i,"Field3"] <-  min(bigbase[bigbase$PKey==families[i,"Father"] & bigbase$IKey==families[i,"IKey"],"Field3"])
families[i,"SField1"] <-  min(bigbase[bigbase$PKey==families[i,"Son"] & bigbase$IKey==families[i,"IKey"],"Field"])
families[i,"SField2"] <-  min(bigbase[bigbase$PKey==families[i,"Son"] & bigbase$IKey==families[i,"IKey"],"Field2"])
families[i,"SField3"] <-  min(bigbase[bigbase$PKey==families[i,"Son"] & bigbase$IKey==families[i,"IKey"],"Field3"])
families[i,"Catholic"] <- ifelse(institutions[institutions$IKey==families[i,"IKey"],"CathSecularU"]==T | 
   institutions[institutions$IKey==families[i,"IKey"],"CatholicA"]==T |
   institutions[institutions$IKey==families[i,"IKey"],"CathJesuitU"]==T,1,0)
families[i,"Protestant"] <- ifelse(institutions[institutions$IKey==families[i,"IKey"],"ProtCalvinistU"]==T | 
   institutions[institutions$IKey==families[i,"IKey"],"ProtAnglicanU"]==T |
   institutions[institutions$IKey==families[i,"IKey"],"ProtLutheranU"]==T |
   institutions[institutions$IKey==families[i,"IKey"],"ProtPresbyterianU"]==T | 
   institutions[institutions$IKey==families[i,"IKey"],"LutheranA"]==T |
   institutions[institutions$IKey==families[i,"IKey"],"CalvinistA"]==T | 
   institutions[institutions$IKey==families[i,"IKey"],"AnglicanA"]==T | 
   institutions[institutions$IKey==families[i,"IKey"],"PresbyterianA"]==T,1,0)
families[i,"University"] <- ifelse(institutions[institutions$IKey==families[i,"IKey"],"University"]==-1,1,0)
families[i,"New"]<-  ifelse(institutions[institutions$IKey==families[i,"IKey"],"CreationDate"]>1542,1,0)
place<- institutions[institutions$IKey==families[i,"IKey"],"Headquarter"]
families[i,"Country"] <- substr(place,nchar(place)-2,nchar(place))
families[i,"SameField"] <- ifelse(length(setdiff(
intersect(c(families[i,"Field1"] ,families[i,"Field2"],families[i,"Field3"]),c(families[i,"SField1"],families[i,"SField2"],families[i,"SField3"])),
"NA") )>1,1,0)
families[i,"CovComprehensive"] <- bigbase[bigbase$PKey==families[i,"Son"] & bigbase$IKey==families[i,"IKey"],"CovComprehensive"]
families[i,"CovBroad"] <- bigbase[bigbase$PKey==families[i,"Son"] & bigbase$IKey==families[i,"IKey"],"CovBroad"]
}


#compute the refdate of the youngest father
for (i in ilist){
instit[instit$IKey==i,"Youngest"] <- min(families[families$IKey==i,"Fdate"])
instit[instit$IKey==i,"Oldest"] <- max(families[families$IKey==i,"Fdate"])
}


threshold_sel<-0
#select only institutions with more than xx cases
sel_i_list <- instit[instit$Nb>threshold_sel,"IKey"]
families <- families[families$IKey %in% sel_i_list,]


#HERE we take the library holdings as a measure of publications
families$Spubli <- asinh(families$Slibh)
families$Fpubli <- asinh(families$Flibh)

sink("moments.txt")

print("Fathers' publis as a function of time")
reg <- lm (Fpubli~Fdate,data=families[families$Fpubli>0,])
summary(reg)

print("Number of families in four cases: No one in Worldcat, Father in WC son not, Son in Wc father not, both in WC")
#display number of cases by presence in WorldCat
table(families$Sin,families$Fin)


cor(families$Sin,families$Fin,method="spearman")

#defining set of families with positive publications
families2 <- families[families$Spubli>0 & families$Fpubli>0,]
cor(families2$Spubli,families2$Fpubli)
nrow(families2)


#display number of cases by presence in WorldCat vs Wiki

table(families$Sin,families$Sinwiki)
table(families$Fin,families$Finwiki)



#regressions
fit1<-lm(Spubli ~ Fpubli,data=families)
fit2<-lm(Spubli ~ Fpubli,data=families2)

stargazer(fit1,fit2)


#list of sons
list_sons <- unique(families$Son)

#fathers who are themselves sons whom I will eliminate to compute fathers moments
list_fathers <- families[families$Father %in% list_sons,"Father"]
list_grandsons <-  families[families$Father %in% list_fathers,"Son"]

gfamilies <- data.frame("GrandFather"=character(),"GrandSon"=character(),"YearGF"=numeric(),"GFpubli"=numeric(),"GSpubli"=numeric(), 
                                 "GFin"=numeric(),"GSin"=numeric(),stringsAsFactors=FALSE)

ngfamil<-length(list_grandsons)


for (v in (1:ngfamil)){
grdson <- list_grandsons[v]
gfamilies[v,"GrandSon"]<-grdson
gfamilies[v,"GSpubli"]<-unique(families[families$Son==grdson,"Spubli"])
gfamilies[v,"GSin"]<-unique(families[families$Son==grdson,"Sin"])
son <- unique(families[families$Son==grdson,"Father"])
grdfather <- unique(families[families$Son==son,"Father"])
gfamilies[v,"GrandFather"]<-grdfather
gfamilies[v,"GFpubli"]<-unique(families[families$Father==grdfather,"Fpubli"])
gfamilies[v,"GFin"]<-unique(families[families$Father==grdfather,"Fin"])
gfamilies[v,"YearGF"]<-unique(families[families$Father==grdfather,"Fdate"])
}

gfamilies <- gfamilies[!(gfamilies$GrandFather %in% list_sons),]



#list of moments
mom<-numeric(13)
PD<- nrow(families)
mom[1] <- cor(families[!(families$Father %in% list_sons) & families$Fin>0 & families$Sin>0,"Fpubli"],
                               families[!(families$Father %in% list_sons) & families$Fin>0 & families$Sin>0,"Spubli"])
mom[2] <- nrow(families[families$Sin==0,])/PD #density at 0 for sons
mom[3]<- as.numeric(quantile(families$Spubli,0.5)) #median for sons
mom[4]<- as.numeric(quantile(families$Spubli,0.75)) # third quartile for sons
mom[5]<- as.numeric(quantile(families$Spubli,0.95)) #upper tail for sons
mom[6]<-mean(families$Spubli)
mom[7] <- nrow(families[!(families$Father %in% list_sons) & families$Fin==0,])/nrow(families[!(families$Father %in% list_sons),]) #same four moments for fathers
mom[8]<- as.numeric(quantile(families[!(families$Father %in% list_sons),"Fpubli"],0.5))
mom[9]<- as.numeric(quantile(families[!(families$Father %in% list_sons),"Fpubli"],0.75))
mom[10]<- as.numeric(quantile(families[!(families$Father %in% list_sons),"Fpubli"],0.95))
mom[11]<-mean(families[!(families$Father %in% list_sons),"Fpubli"])
mom[12]<- nrow(families[families$Fin==0 & families$Sin==0,])/PD
mom[13] <- cor(gfamilies[gfamilies$GFin>0 & gfamilies$GSin>0,"GFpubli"],
                       gfamilies[gfamilies$GFin>0 & gfamilies$GSin>0,"GSpubli"])


nf<-nrow(families[!(families$Father %in% list_sons),])
print(c("number of fathers:",nf))

ns<-nrow(families)
print(c("number of sons",ns))

print(c("number of published families",length(families[families$Fin>0 & families$Sin>0,"Fpubli"])))

print(c("number of multi generations families",nrow(gfamilies)))
print(c("number of published multi generations families",length(gfamilies[gfamilies$GFin>0 & gfamilies$GSin>0,"GFpubli"])))


print("Cases for which birth date is known")
(nrow(families[!(families$Father %in% list_sons) & !is.na(families$Fborn),])+
   nrow(families[!is.na(families$Sborn),]))/(nf+ns)

print("Cases for which death date is known")
(nrow(families[!(families$Father %in% list_sons) & !is.na(families$Fdied),])+
   nrow(families[!is.na(families$Sdied),]))/(nf+ns)

print("Cases for which nomination date is known")
(nrow(families[!(families$Father %in% list_sons) & !is.na(families$Fstart),])+
   nrow(families[!is.na(families$Sstart),]))/(nf+ns)

labels<- c("corr(F,S)","% S with 0","Q50 S","Q75 S","Q95 S","Mean S","% F with 0",
"Q50 F","Q75 F","Q95 F","Mean F","% S&F with 0","corr(GF,GS)")
cbind(labels,round(mom,3))



summary(families)
summary(gfamilies)


sink()

#Life expectancy business
families$Flongevity <- families$Fdied-families$Fborn
families$Slongevity <- families$Sdied-families$Sborn

mean(families$Flongevity,na.rm=T)
mean(families$Slongevity,na.rm=T)

regFlong<-lm(Fpubli~ 1,data=families)
regSlong<-lm(Spubli~ Slongevity,data=families)

summary(regFlong)
summary(regSlong)

#save what was found
write_xlsx(families,"Families-publis.xlsx")
write_xlsx(gfamilies,"GFamilies-publis.xlsx")
write_xlsx(instit,"Institutions with families.xlsx")



