
## remove (almost) everything in the working environment.
rm(list = ls())


# to import xl files
library(readxl)
# to plot maps
library(rnaturalearth,rnaturalearthdata)
library("ggplot2")
library("sf")

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\base")
#load database of families
families <- as.data.frame(read_excel("families.xlsx"))
nfamil<-nrow(families)
#Opening the base containing geo localisation for each individual
basew <- as.data.frame(read_excel("Profs.xlsx"))



setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\database")

#loading functions
source('scale.R') # to put a scale on a map


#=========================================================================================



families$cases<-0
for (i in 1:nfamil)
{j<-families[i,"IKey"]
families[i,"cases"]<-nrow(families[families$IKey==j,])
}


#collect longitude and latitude. Perturb a bit birth places to better see them on map
for (i in 1:nfamil)
{
families[i,"SLongBirth"] <-  unique(basew[basew$PKey==families[i,"Son"] & basew$IKey==families[i,"IKey"],"Locations_Longitude"]) +(runif(1)-.5)/4
families[i,"SLatBirth"] <-  unique(basew[basew$PKey==families[i,"Son"] & basew$IKey==families[i,"IKey"],"Locations_Latitude"]) +(runif(1)-.5)/4

families[i,"FLongBirth"] <-  unique(basew[basew$PKey==families[i,"Father"] & basew$IKey==families[i,"IKey"],"Locations_Longitude"])+(runif(1)-.5)/4
families[i,"FLatBirth"] <-  unique(basew[basew$PKey==families[i,"Father"] & basew$IKey==families[i,"IKey"],"Locations_Latitude"])+(runif(1)-.5)/4

families[i,"SLongDest"] <-  unique(basew[basew$PKey==families[i,"Son"] & basew$IKey==families[i,"IKey"],"Locations_2_Longitude"]) 
families[i,"SLatDest"] <-  unique(basew[basew$PKey==families[i,"Son"]  & basew$IKey==families[i,"IKey"],"Locations_2_Latitude"]) 
}
print(i)

places <- unique(families[,c("SLongDest","SLatDest","cases")])


blank1 <- ne_coastline(scale = "large", returnclass = "sf")
blank2 <- ne_countries(scale = "large",type = 'countries', returnclass = "sf")
theme_set(theme_bw())


#a  plot
bftp1<-ggplot(data = blank2)+theme(panel.background = element_rect(fill = "aliceblue"))+
    geom_sf(colour = "gray80",fill="gray80")+coord_sf(xlim=c(-8,39),ylim=c(36,62))+
geom_point(aes(x=SLongBirth,y=SLatBirth,fill="Son's \n birth place"),colour="black",shape=22,data=families,alpha=.6,size=2)+
geom_point(aes(x=FLongBirth,y=FLatBirth,fill="Father's \n  birth place"),colour="black",shape=22,data=families,alpha=.6,size=2)+
 theme(legend.title =element_blank())+
 scale_fill_manual(values = c("red", "orange"))+
geom_point(aes(x=SLongDest,y=SLatDest,size=cases),fill="lightgreen",colour="black",shape=21,alpha=.6,data=places)+
 scale_size(breaks=c(1,5,25,50,100,157),range = c(4, 12),name="Covered \n institutions",
         labels=c("Institutions \n with 1 lineage","with 2-5","with 6-25","with 26-50","with 51-100","with 101-157"))+
scale_bar(lon = -8., lat = 62,distance_lon = 300, distance_lat = 30,distance_legend = 100, dist_unit = "km", orientation = FALSE)+
geom_segment(arrow=arrow(length=unit(2.5,"mm"), type="closed", angle=30),aes(x=-8.5,xend=-8.5,y=45.2,yend=46.3), colour=rgb(.4,.4,.4))+
geom_label(aes(x=-8.5, y=45.5, label="N"),size=2.5, label.padding=unit(1,"mm"), label.r=unit(0.4,"lines")) +
theme(legend.position = c(0.88, 0.305),axis.title=element_blank(),axis.text=element_blank(),axis.ticks=element_blank(),
 panel.grid.major = element_line(colour = 'transparent'))
plot(bftp1)

pdf(file='map-families.pdf', width = 10, height = 7)
plot(bftp1, main="")
dev.off()

