

## remove (almost) everything in the working environment.
rm(list = ls())


# to import xl files
library(readxl)
#to write excel files
require(writexl)

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\base")

#load database of all
hono <- as.data.frame(read_excel("Profs.xlsx"))  #this takes all people 
listhono <- unique(hono[hono$Field=="9","PKey"]) #list of honorary people

all0 <- as.data.frame(read_excel("Profs-wiki-all.xlsx"))  #this takes all people 
all <- as.data.frame(read_excel("Dictionary.xlsx"))  # this would be the whole database

all<-all[!(all$PKey %in% listhono),]  #&  remove honorific members

listallp<-unique(all$PKey)

for (p in listallp){
all[all$PKey==p,"date"]<-all0[all0$PKey==p,"refdatel"]

all[all$PKey==p,"covC"]<-max(hono[hono$PKey==p,"CovComprehensive"])
all[all$PKey==p,"covB"]<-max(hono[hono$PKey==p,"CovBroad"])
}


setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\database")
#load database of families
families <- as.data.frame(read_excel("families-publis.xlsx"))

#######################Sons


#remove sons from outsiders
list_sons<-unique(families$Son)
all <- all[!(all$PKey %in% list_sons),]

all$publi<- asinh(all$nlib)

my_data <- data.frame( 
                group = c(rep("Sons",nrow(families)),rep("All",nrow(all))),
                PKey=c(families$Son,all$PKey),
                publications= c(families$Spubli,all$publi),
                wiki=c(families$Sinwiki,all$pagewiki),
                worldcat=c(families$Sin,all$pagewc),
                date=c(families$Sdate,all$date),
                covComprehensive=c(families$CovComprehensive,all$covC),
                covBroad=c(families$CovBroad,all$covB) 
                )


summary(my_data)


write_xlsx(my_data,"Sons-and-all.xlsx")


