

## remove (almost) everything in the working environment.
rm(list = ls())


# to import xl files
library(readxl)

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\database")
#load database of families
families <- as.data.frame(read_excel("families-publis.xlsx"))

#upper bound for axes
maxp <- max(c(families$Fpubli,families$Fpubli))

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\estimation")
families2 <- as.data.frame(read_excel("simulated publi mod2.xlsx"))
families3 <- as.data.frame(read_excel("simulated publi mod3.xlsx"))

###########################QQ : all ######################################################
pdf("QQ-plot-fit.pdf", width = 8 , height = 8)

par(mgp=c(2.5,1,0),mar=c(5,4,4,2)+0.1)
qqplot(families$Fpubli,families$Spubli,xlab="Fathers' publications",
ylab="Sons' publications",xlim=c(0,maxp),ylim=c(0,maxp), main=NULL,cex=.6,lwd=2,type = "b")
abline(a=0,b=1)

legend(0, 12.5, legend="Data",pt.lwd=2,cex=0.6,box.lty=0,pch=1)

par(new=TRUE)

qqplot(families2$FPubli,families2$SPubli,xlab=" ",ylab=" ",type = "b",
xlim=c(0,maxp),ylim=c(0,maxp), main=NULL,pch=1,col="gold3",cex=.6,lwd=2)

legend(0, 11.5, legend="Simulation w/o nepotism",pt.lwd=2,cex=0.6,box.lty=0,pch=1,col="gold3")

par(new=TRUE)

qqplot(families3$FPubli,families3$SPubli,xlab=" ",ylab=" ",type = "b",
xlim=c(0,maxp),ylim=c(0,maxp), main=NULL,pch=1,col="darkred",cex=.6,lwd=2)

legend(0, 10.5, legend="Simulation benchmark",pt.lwd=2,cex=0.6,box.lty=0,pch=1,col="darkred")

dev.off()



######cdf

# calculate CDF  
CDF1 <- ecdf(families$Fpubli ) 
CDF2 <- ecdf(families$Spubli ) 
CDF3 <- ecdf(families2$FPubli ) 
CDF4 <- ecdf(families2$SPubli ) 
CDF5 <- ecdf(families3$FPubli ) 
CDF6 <- ecdf(families3$SPubli ) 
  
# draw the cdf plot 
plot( CDF1,xlim=c(0,12), lty = 1 )
lines(CDF2,col="red",lty=1)

plot( CDF3,xlim=c(0,12),lwd=4 )
lines(CDF4,col="red",lwd=3,lty=3)

plot( CDF5,xlim=c(0,12),lwd=4 )
lines(CDF6,col="red",lwd=3,lty=3)


