## remove (almost) everything in the working environment.
rm(list = ls())

# to import excel files
if (!require('readxl')) install.packages('readxl'); library('readxl')

require(tidyverse)

if (!require('forecast')) install.packages('forecast'); library('forecast')
# ma: Moving-average smoothing

if (!require('mFilter')) install.packages('mFilter'); library('mFilter')	
 # for hp filter
require(writexl)

# set the directory to where the files are located
setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\base")
#load database 
persons <- as.data.frame(read_excel("Profs-wiki-all.xlsx"))
instit <- as.data.frame(read_excel("Institutions-All.xlsx"))
bigbase <- as.data.frame(read_excel("Profs.xlsx"))



plist <- persons$PKey
npers <-length(plist)

persons$cath <-0
persons$prot <-0 

print("loop to find religion")
for (p in (1:npers)){
tmp <- bigbase[bigbase$PKey==plist[p],]
seti <- instit[instit$IKey %in% tmp$IKey,]

if(p==as.integer(p/5000)*5000){print(c(p,"done"))}

cathtp <- ifelse(persons[p,]$refdatel<1528 | (TRUE %in% seti$CathSecularU |  TRUE %in% seti$CatholicA | TRUE %in% seti$CathJesuitU),1,0)
prottp <- ifelse(persons[p,]$refdatel>1527 & (TRUE %in% seti$ProtCalvinistU | TRUE %in% seti$ProtAnglicanU |	TRUE %in% seti$ProtLutheranU | 
TRUE %in% seti$ProtPresbyterianU | TRUE %in% seti$CalvinistA | TRUE %in% seti$AnglicanA | TRUE %in% seti$LutheranA | 
TRUE %in% seti$PresbyterianA),1,0) 

persons[p,]$cath <- ifelse(cathtp+prottp>0,cathtp/(cathtp+prottp),0)
persons[p,]$prot <- ifelse(cathtp+prottp>0,prottp/(cathtp+prottp),0)
}


persons$med<-0
persons$theo<-0
persons$sci<-0
persons$law<-0
persons$hum<-0
persons$app<-0

print("loop to find fields")
for (p in (1:npers)){

if(p==as.integer(p/5000)*5000){print(c(p,"done"))}

tmp <- bigbase[bigbase$PKey==plist[p],]
fields <- unique(setdiff(c(tmp$Field,tmp$Field2,tmp$Field3),c("?",NA)))
nfields <-length(fields)
if (nfields>0){
persons[p,]$med <- ifelse("4" %in% fields,1/nfields,0)
persons[p,]$theo <- ifelse("1" %in% fields,1/nfields,0)
persons[p,]$sci <- ifelse("5" %in% fields,1/nfields,0)
persons[p,]$law <- ifelse("2" %in% fields,1/nfields,0)
persons[p,]$hum <- ifelse("3" %in% fields,1/nfields,0)
persons[p,]$app <- ifelse("6" %in% fields,1/nfields,0)
}
}

 
persmed<-rep(0, times=801)
publimed<-rep(0, times=801)
publimedcath<-rep(0, times=801)
publimedprot<-rep(0, times=801)

perstheo<-rep(0, times=801)
publitheo<-rep(0, times=801)
publitheocath<-rep(0, times=801)
publitheoprot<-rep(0, times=801)

perssci<-rep(0, times=801)
publisci<-rep(0, times=801)
publiscicath<-rep(0, times=801)
publisciprot<-rep(0, times=801)

perslaw<-rep(0, times=801)
publilaw<-rep(0, times=801)
publilawcath<-rep(0, times=801)
publilawprot<-rep(0, times=801)

pershum<-rep(0, times=801)
publihum<-rep(0, times=801)
publihumcath<-rep(0, times=801)
publihumprot<-rep(0, times=801)

persapp<-rep(0, times=801)
publiapp<-rep(0, times=801)
publiappcath<-rep(0, times=801)
publiappprot<-rep(0, times=801)

year<-rep(0, times=801)

for (t in (1000:1800)){

year[t-999]<-t

sett <- persons[persons$med>0 & persons$refdatel<=t & persons$refdateh>=t,"PKey"]
persmed[t-999]<-sum(persons[persons$PKey %in% sett,"med"])
publimed[t-999] <- sum(persons[persons$PKey %in% sett,"nworks"]*persons[persons$PKey %in% sett,"med"])
publimedcath[t-999] <- sum(persons[persons$PKey %in% sett,"nworks"]*persons[persons$PKey %in% sett,"med"]*persons[persons$PKey %in% sett,"cath"])
publimedprot[t-999] <- sum(persons[persons$PKey %in% sett,"nworks"]*persons[persons$PKey %in% sett,"med"]*persons[persons$PKey %in% sett,"prot"])

sett <- persons[persons$theo>0 & persons$refdatel<=t & persons$refdateh>=t,"PKey"]
perstheo[t-999]<-sum(persons[persons$PKey %in% sett,"theo"])
publitheo[t-999] <- sum(persons[persons$PKey %in% sett,"nworks"]*persons[persons$PKey %in% sett,"theo"])
publitheocath[t-999] <- sum(persons[persons$PKey %in% sett,"nworks"]*persons[persons$PKey %in% sett,"theo"]*persons[persons$PKey %in% sett,"cath"])
publitheoprot[t-999] <- sum(persons[persons$PKey %in% sett,"nworks"]*persons[persons$PKey %in% sett,"theo"]*persons[persons$PKey %in% sett,"prot"])

sett <- persons[persons$sci>0 & persons$refdatel<=t & persons$refdateh>=t,"PKey"]
perssci[t-999]<-sum(persons[persons$PKey %in% sett,"sci"])
publisci[t-999] <- sum(persons[persons$PKey %in% sett,"nworks"]*persons[persons$PKey %in% sett,"sci"])
publiscicath[t-999] <- sum(persons[persons$PKey %in% sett,"nworks"]*persons[persons$PKey %in% sett,"sci"]*persons[persons$PKey %in% sett,"cath"])
publisciprot[t-999] <- sum(persons[persons$PKey %in% sett,"nworks"]*persons[persons$PKey %in% sett,"sci"]*persons[persons$PKey %in% sett,"prot"])


sett <- persons[persons$law>0 & persons$refdatel<=t & persons$refdateh>=t,"PKey"]
perslaw[t-999]<-sum(persons[persons$PKey %in% sett,"law"])
publilaw[t-999] <- sum(persons[persons$PKey %in% sett,"nworks"]*persons[persons$PKey %in% sett,"law"])
publilawcath[t-999] <- sum(persons[persons$PKey %in% sett,"nworks"]*persons[persons$PKey %in% sett,"law"]*persons[persons$PKey %in% sett,"cath"])
publilawprot[t-999] <- sum(persons[persons$PKey %in% sett,"nworks"]*persons[persons$PKey %in% sett,"law"]*persons[persons$PKey %in% sett,"prot"])

sett <- persons[persons$hum>0 & persons$refdatel<=t & persons$refdateh>=t,"PKey"]
pershum[t-999]<-sum(persons[persons$PKey %in% sett,"hum"])
publihum[t-999] <- sum(persons[persons$PKey %in% sett,"nworks"]*persons[persons$PKey %in% sett,"hum"])
publihumcath[t-999] <- sum(persons[persons$PKey %in% sett,"nworks"]*persons[persons$PKey %in% sett,"hum"]*persons[persons$PKey %in% sett,"cath"])
publihumprot[t-999] <- sum(persons[persons$PKey %in% sett,"nworks"]*persons[persons$PKey %in% sett,"hum"]*persons[persons$PKey %in% sett,"prot"])

sett <- persons[persons$app>0 & persons$refdatel<=t & persons$refdateh>=t,"PKey"]
persapp[t-999]<-sum(persons[persons$PKey %in% sett,"app"])
publiapp[t-999] <- sum(persons[persons$PKey %in% sett,"nworks"]*persons[persons$PKey %in% sett,"app"])
publiappcath[t-999] <- sum(persons[persons$PKey %in% sett,"nworks"]*persons[persons$PKey %in% sett,"app"]*persons[persons$PKey %in% sett,"cath"])
publiappprot[t-999] <- sum(persons[persons$PKey %in% sett,"nworks"]*persons[persons$PKey %in% sett,"app"]*persons[persons$PKey %in% sett,"prot"])

}




setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\high-low-growth")


coltheo <- rgb(181/255, 0, 48/255)
collaw <- rgb(226/255, 0, 38/255)
colmed <- rgb(136/255, 0/255, 93/255)
colsci <-rgb(0/255, 78/255, 156/255)
colhum<-rgb(242/255, 148/255, 0)
colapp<-rgb(74/255, 150/255, 205/255)


top <- max(asinh(publilaw),asinh(publitheo),asinh(publisci),asinh(publihum),asinh(publiapp),asinh(publimed))




pdf(file='hpfilter.pdf', width = 10, height = 7)


plot(hpfilter(asinh(publimedcath),freq=100000,type="lambda")$trend~year, type = "l",lty=1,
  ylab="asinh no. publications in catholic institutions",
        sub="lambda: 1 (green), 1000 (red), 100000 (black), 1000000 (blue)")
lines(hpfilter(asinh(publimedcath),freq=1000,type="lambda")$trend~year,col="red")
lines(hpfilter(asinh(publimedcath),freq=1,type="lambda")$trend~year,col="green")
lines(hpfilter(asinh(publimedcath),freq=1000000,type="lambda")$trend~year,col="blue")
title(main="Publications of Catholic physicians 1000-1800 by religion",)

dev.off()

param<-1000000

publimedcathhp <- hpfilter(asinh(publimedcath),freq=param,type="lambda")$trend
publimedprothp <- hpfilter(asinh(publimedprot),freq=param,type="lambda")$trend
publitheocathhp <- hpfilter(asinh(publitheocath),freq=param,type="lambda")$trend
publitheoprothp <- hpfilter(asinh(publitheoprot),freq=param,type="lambda")$trend
publilawcathhp <- hpfilter(asinh(publilawcath),freq=param,type="lambda")$trend
publilawprothp <- hpfilter(asinh(publilawprot),freq=param,type="lambda")$trend
publiscicathhp <- hpfilter(asinh(publiscicath),freq=param,type="lambda")$trend
publisciprothp <- hpfilter(asinh(publisciprot),freq=param,type="lambda")$trend
publihumcathhp <- hpfilter(asinh(publihumcath),freq=param,type="lambda")$trend
publihumprothp <- hpfilter(asinh(publihumprot),freq=param,type="lambda")$trend
publiappcathhp <-hpfilter(asinh(publiappcath),freq=param,type="lambda")$trend
publiappprothp <- hpfilter(asinh(publiappprot),freq=param,type="lambda")$trend




pdf(file='med by relig over time.pdf', width = 10, height = 7)

plot(publimedcathhp~year,xlab="Year",ylab="Number of Works (log scale)",type="l",
col=colmed,lwd=2,lty=1,ylim=c(0,top),xlim=c(1200,1800))

title(main="Publications of physicians 1200-1800 by religion")

lines(publimedprothp~year,col=colmed,lw=2,lty=2)

legend(1000, top/2, legend=c("Catholic", "Protestant"),col=colmed, lty=c(1,2),lw=2, cex=1,box.lty=0)

dev.off()


pdf(file='theo by relig over time.pdf', width = 10, height = 7)

plot(publitheocathhp~year,xlab="Year",ylab="Number of Works (log scale)",type="l",
col=coltheo,lwd=2,lty=1,ylim=c(0,top),xlim=c(1200,1800))

title(main="Publications of theologians 1200-1800 by religion")

lines(publitheoprothp~year,col=coltheo,lw=2,lty=2)

legend(1000, top/2,legend=c("Catholic", "Protestant"),col=coltheo, lty=c(1,2),lw=2, cex=1,box.lty=0)

dev.off()


pdf(file='law by relig over time.pdf', width = 10, height = 7)

plot(publilawcathhp~year,xlab="Year",ylab="Number of Works (log scale)",type="l",
col=collaw,lwd=2,lty=1,ylim=c(0,top),xlim=c(1200,1800))

title(main="Publications of lawyers 1200-1800 by religion")

lines(publilawprothp~year,col=collaw,lw=2,lty=2)

legend(1000, top/2, legend=c("Catholic", "Protestant"),col=collaw, lty=c(1,2),lw=2, cex=1,box.lty=0)

dev.off()


pdf(file='sci by relig over time.pdf', width = 10, height = 7)

plot(publiscicathhp~year,xlab="Year",ylab="Number of Works (log scale)",type="l",
col=colsci,lwd=2,lty=1,ylim=c(0,top),xlim=c(1200,1800))

title(main="Publications of scientists 1200-1800 by religion")

lines(publisciprothp~year,col=colsci,lw=2,lty=2)

legend(1000, top/2, legend=c("Catholic", "Protestant"),col=colsci, lty=c(1,2),lw=2, cex=1,box.lty=0)

dev.off()


pdf(file='hum by relig over time.pdf', width = 10, height = 7)

plot(publihumcathhp~year,xlab="Year",ylab="Number of Works (log scale)",type="l",
col=colhum,lwd=2,lty=1,ylim=c(0,top),xlim=c(1200,1800))

title(main="Publications of artists 1000-1800 by religion")

lines(publihumprothp~year,col=colhum,lw=2,lty=2)

legend(1000, top/2, legend=c("Catholic", "Protestant"),col=colhum, lty=c(1,2),lw=2, cex=1,box.lty=0)

dev.off()

pdf(file='app by relig over time.pdf', width = 10, height = 7)

plot(publiappcathhp~year,xlab="Year",ylab="Number of Works (log scale)",type="l",
col=colapp,lwd=2,lty=1,ylim=c(0,top),xlim=c(1200,1800))

title(main="Publications of applied scientists 1200-1800 by religion")

lines(publiappprothp~year,col=colapp,lw=2,lty=2)

legend(1000, top/2, legend=c("Catholic", "Protestant"),col=colapp, lty=c(1,2),lw=2, cex=1,box.lty=0)

dev.off()




publimedcathgrowth <-rep(NA, times=801)
publimedprotgrowth <- rep(NA, times=801)
publitheocathgrowth <-rep(NA, times=801)
publitheoprotgrowth <-rep(NA, times=801)
publilawcathgrowth <- rep(NA, times=801)
publilawprotgrowth <- rep(NA, times=801)
publiscicathgrowth <- rep(NA, times=801)
publisciprotgrowth <-rep(NA, times=801)  
publihumcathgrowth <- rep(NA, times=801)
publihumprotgrowth<- rep(NA, times=801)
publiappcathgrowth <-rep(NA, times=801)
publiappprotgrowth <- rep(NA, times=801)

for (t in (1200:1800)){

publimedcathgrowth[t-999] <- try(publimedcathhp[t-999]-publimedcathhp[t-999-25])  
publimedprotgrowth[t-999] <- try(publimedprothp[t-999]-publimedprothp[t-999-25] ) 

publitheocathgrowth[t-999] <- try(publitheocathhp[t-999]-publitheocathhp[t-999-25])  
publitheoprotgrowth[t-999] <- try(publitheoprothp[t-999]-publitheoprothp[t-999-25])  

publilawcathgrowth[t-999] <- try(publilawcathhp[t-999]-publilawcathhp[t-999-25])  
publilawprotgrowth[t-999] <- try(publilawprothp[t-999]-publilawprothp[t-999-25])  

publiscicathgrowth[t-999] <- try(publiscicathhp[t-999]-publiscicathhp[t-999-25])  
publisciprotgrowth[t-999] <- try(publisciprothp[t-999]-publisciprothp[t-999-25])  

publihumcathgrowth[t-999] <- try(publihumcathhp[t-999]-publihumcathhp[t-999-25])  
publihumprotgrowth[t-999] <- try(publihumprothp[t-999]-publihumprothp[t-999-25])  

publiappcathgrowth[t-999] <- try(publiappcathhp[t-999]-publiappcathhp[t-999-25])  
publiappprotgrowth[t-999] <- try(publiappprothp[t-999]-publiappprothp[t-999-25])  
}


pdf(file='growth rates.pdf', width = 30, height = 10)

par(mfrow=c(2,6))

plot(publitheocathgrowth~year,ylim=c(-1,1),col=ifelse(publitheocathgrowth>0,"green","red"),xlim=c(1525,1800),ylab="Catholic theology")

plot(publilawcathgrowth~year,ylim=c(-1,1),col=ifelse(publilawcathgrowth>0,"green","red"),xlim=c(1525,1800),ylab="Catholic law")

plot(publihumcathgrowth~year,ylim=c(-1,1),col=ifelse(publihumcathgrowth>0,"green","red"),xlim=c(1525,1800),ylab="Catholic arts & humanities")

plot(publimedcathgrowth~year,ylim=c(-1,1),col=ifelse(publimedcathgrowth>0,"green","red"),xlim=c(1525,1800),ylab="Catholic medicine")

plot(publiscicathgrowth~year,ylim=c(-1,1),col=ifelse(publiscicathgrowth>0,"green","red"),xlim=c(1525,1800),ylab="Catholic sciences")

plot(publiappcathgrowth~year,ylim=c(-2,2),col=ifelse(publiappcathgrowth>0,"green","red"),xlim=c(1525,1800),ylab="Catholic applied sciences")

plot(publitheoprotgrowth~year,ylim=c(-1,1),col=ifelse(publitheoprotgrowth>0,"green","red"),xlim=c(1525,1800),ylab="Protestant theology")

plot(publilawprotgrowth~year,ylim=c(-1,1),col=ifelse(publilawprotgrowth>0,"green","red"),xlim=c(1525,1800),ylab="Protestant law")

plot(publihumprotgrowth~year,ylim=c(-1,1),col=ifelse(publihumprotgrowth>0,"green","red"),xlim=c(1525,1800),ylab="Protestant arts & humanities")

plot(publimedprotgrowth~year,ylim=c(-1,1),col=ifelse(publimedprotgrowth>0,"green","red"),xlim=c(1525,1800),ylab="Protestant medicine")

plot(publisciprotgrowth~year,ylim=c(-1,1),col=ifelse(publisciprotgrowth>0,"green","red"),xlim=c(1525,1800),ylab="Protestant aciences")

plot(publiappprotgrowth~year,ylim=c(-2,2),col=ifelse(publiappprotgrowth>0,"green","red"),xlim=c(1525,1800),ylab="Protestant applied sciences")

#mtext("Growth rate of fields-religions over time", side = 3, line = -2, outer = TRUE)

dev.off()


write_xlsx(as.data.frame(cbind(year,publitheocathgrowth,publilawcathgrowth,publihumcathgrowth,publimedcathgrowth,publiscicathgrowth,publiappcathgrowth,
publitheoprotgrowth,publilawprotgrowth,publihumprotgrowth,publimedprotgrowth,publisciprotgrowth,publiappprotgrowth)),"fields-over-time.xlsx")



