
## remove (almost) everything in the working environment.
rm(list = ls())

 
# to import xl files
if(!require(readxl)) {install.packages("readxl"); require(readxl)} 



setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\database")

#load database of families
familiesb <- as.data.frame(read_excel("Families-publis.xlsx"))
Ndata0<- nrow(familiesb)
familiesb <- familiesb[familiesb$Sinwiki>0 | familiesb$Finwiki>0 | familiesb$Sinwc>0 | familiesb$Finwc>0,]  # keep families with wiki or wc
Ndata<- nrow(familiesb)

gfamiliesb <- as.data.frame(read_excel("GFamilies-publis.xlsx"))
listfathers <- unique(familiesb$Father)
gfamiliesb[gfamiliesb$GrandFather %in% listfathers,]    


#printing some counts
list_sons <- unique(familiesb$Son)
nf<-nrow(familiesb[!(familiesb$Father %in% list_sons),])
print(c("number of fathers:",nf))

ns<-nrow(familiesb)
print(c("number of sons",ns))

print(c("number of published families",length(familiesb[familiesb$Fin>0 & familiesb$Sin>0,"Fpubli"])))


print(c("number of multi generations families",nrow(gfamiliesb)))

print(c("number of published multi generations families",length(gfamiliesb[gfamiliesb$GFin>0 & gfamiliesb$GSin>0,"GFpubli"])))



setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\base")

outsidersb <-as.data.frame(read_excel("Profs-wiki-all.xlsx"))
outsidersb <- outsidersb[!(outsidersb$PKey %in% familiesb$Father),]  # remove families from outsiders
outsidersb <- outsidersb[!(outsidersb$PKey %in% familiesb$Son),]
Odata0<-nrow(outsidersb)
outsidersb <- outsidersb[outsidersb$pagewiki==1 | outsidersb$pagewc==1,]           # keep outsiders with wiki
Odata<-nrow(outsidersb)

#select outsiders in the same decade IKEY than sons
profs <-as.data.frame(read_excel("Profs.xlsx"))  #we need profs to get institutions
profs<-profs[,c("PKey","IKey")]
profs<-profs[profs$PKey %in% outsidersb$PKey,]

total <- merge(profs,outsidersb,by="PKey")
outsidersb <- total

crit<-unique(paste(familiesb$IKey,"+",floor(familiesb$Sdate/10),sep=""))
nrow(outsidersb)
outsidersb <- outsidersb[paste(outsidersb$IKey,"+",floor(outsidersb$refdatel/10),sep="") %in% crit,]
nrow(outsidersb)

df<- subset(outsidersb, select = -c(IKey) )
outsidersb<-unique(df)
nrow(outsidersb)
Odata<-nrow(outsidersb)


outsidersb$nlib <- ifelse(outsidersb$pagewc==1,outsidersb$nlib,0)
outsidersb$Oin <-  as.numeric(outsidersb$pagewc) 
outsidersb$Opubli <- asinh(outsidersb$nlib)



labels<- c("corr(F,S)","% S with 0","Q50 S","Q75 S","Q95 S","Mean S","% F with 0",
"Q50 F","Q75 F","Q95 F","Mean F","% S&F with 0","corr(GF,GS)","% O with 0","Q50 O","Q75 O","Q95 O","Mean O")


#number of draws
set.seed(5) #Use the set.seed function when running simulations to ensure all results, figures, etc are reproducible.
ndraws<-10000
#list of targets
targets<-numeric(18)

targ <- data.frame(corrFS=numeric(),S0=numeric(),SQ50=numeric(),SQ75=numeric(),SQ95=numeric(),
Smean=numeric(),F0=numeric(),FQ50=numeric(),FQ75=numeric(),FQ95=numeric(),
Fmean=numeric(),SF0=numeric(),corrGFGS=numeric(),
O0=numeric(),OQ50=numeric(),OQ75=numeric(),OQ95=numeric(),Omean=numeric())

for (i in (1:ndraws)){

#draw new artifical sample
families <- familiesb[sample(1:Ndata,size=Ndata,replace=T),]
outsiders <- outsidersb[sample(1:Odata,size=Odata,replace=T),]

#build a new gfamilies from the artificial families
list_sons <- unique(families$Son)
list_fathers <- families[families$Father %in% list_sons,"Father"]
list_grandsons <-  families[families$Father %in% list_fathers,"Son"]
gfamilies <- data.frame("GrandFather"=character(),"GrandSon"=character(),"GFpubli"=numeric(),"GSpubli"=numeric(), 
                                 "GFin"=numeric(),"GSin"=numeric(),stringsAsFactors=FALSE)
ngfamil<-length(list_grandsons)
for (v in (1:ngfamil)){
grdson <- list_grandsons[v]
gfamilies[v,"GrandSon"]<-grdson
gfamilies[v,"GSpubli"]<-unique(families[families$Son==grdson,"Spubli"])
gfamilies[v,"GSin"]<-unique(families[families$Son==grdson,"Sin"])
son <- unique(families[families$Son==grdson,"Father"])
grdfather <- unique(families[families$Son==son,"Father"])
gfamilies[v,"GrandFather"]<-grdfather
gfamilies[v,"GFpubli"]<-unique(families[families$Father==grdfather,"Fpubli"])
gfamilies[v,"GFin"]<-unique(families[families$Father==grdfather,"Fin"])
}
gfamilies <- gfamilies[!(gfamilies$GrandFather %in% list_sons),]


#moments
targets[1] <-cor(families[!(families$Father %in% list_sons) & families$Fin>0 & families$Sin>0,"Fpubli"],
                               families[!(families$Father %in% list_sons) & families$Fin>0 & families$Sin>0,"Spubli"])
targets[2] <- nrow(families[families$Sin==0,])/Ndata #density at 0 for sons
targets[3]<- as.numeric(quantile(families$Spubli,0.5)) #median for sons
targets[4]<- as.numeric(quantile(families$Spubli,0.75)) # third quartile for sons
targets[5]<- as.numeric(quantile(families$Spubli,0.95)) #upper tail for sons
targets[6]<-mean(families$Spubli)
targets[7] <- nrow(families[!(families$Father %in% list_sons) & families$Fin==0,])/nrow(families[!(families$Father %in% list_sons),]) #same four moments for fathers
targets[8]<- as.numeric(quantile(families[!(families$Father %in% list_sons),"Fpubli"],0.5))
targets[9]<- as.numeric(quantile(families[!(families$Father %in% list_sons),"Fpubli"],0.75))
targets[10]<- as.numeric(quantile(families[!(families$Father %in% list_sons),"Fpubli"],0.95))
targets[11]<-mean(families[!(families$Father %in% list_sons),"Fpubli"])
targets[12]<- nrow(families[families$Fin==0 & families$Sin==0,])/Ndata
targets[13] <- cor(gfamilies[gfamilies$GFin>0 & gfamilies$GSin>0,"GFpubli"],
                                 gfamilies[gfamilies$GFin>0 & gfamilies$GSin>0,"GSpubli"])

targets[14] <- nrow(outsiders[outsiders$Oin==0,])/Odata #density at 0 for sons
targets[15]<- as.numeric(quantile(outsiders$Opubli,0.5)) #median for sons
targets[16]<- as.numeric(quantile(outsiders$Opubli,0.75)) # third quartile for sons
targets[17]<- as.numeric(quantile(outsiders$Opubli,0.95)) #upper tail for sons
targets[18]<-mean(outsiders$Opubli)

targ[i,]<- targets

}


targets_mean<- apply(targ,2,mean)
targets_se<- apply(targ,2,sd)



setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\outsiders")
sink(file="sink se of moments.txt")

#printing mean and SE of moments

print("mean and SE of simulated targets")
print(round(targets_mean,3))
print(round(targets_se,4))

# printing actual moments
families <- familiesb
gfamilies <- gfamiliesb
outsiders <- outsidersb

#list of sons
list_sons <- unique(families$Son)

targets[1] <-cor(families[!(families$Father %in% list_sons) & families$Fin>0 & families$Sin>0,"Fpubli"],
                               families[!(families$Father %in% list_sons) & families$Fin>0 & families$Sin>0,"Spubli"])
targets[2] <- nrow(families[families$Sin==0,])/Ndata #density at 0 for sons
targets[3]<- as.numeric(quantile(families$Spubli,0.5)) #median for sons
targets[4]<- as.numeric(quantile(families$Spubli,0.75)) # third quartile for sons
targets[5]<- as.numeric(quantile(families$Spubli,0.95)) #upper tail for sons
targets[6]<-mean(families$Spubli)
targets[7] <- nrow(families[!(families$Father %in% list_sons) & families$Fin==0,])/nrow(families[!(families$Father %in% list_sons),]) #same four moments for fathers
targets[8]<- as.numeric(quantile(families[!(families$Father %in% list_sons),"Fpubli"],0.5))
targets[9]<- as.numeric(quantile(families[!(families$Father %in% list_sons),"Fpubli"],0.75))
targets[10]<- as.numeric(quantile(families[!(families$Father %in% list_sons),"Fpubli"],0.95))
targets[11]<-mean(families[!(families$Father %in% list_sons),"Fpubli"])
targets[12]<- nrow(families[families$Fin==0 & families$Sin==0,])/Ndata
targets[13] <- cor(gfamilies[gfamilies$GFin>0 & gfamilies$GSin>0,"GFpubli"],
                                 gfamilies[gfamilies$GFin>0 & gfamilies$GSin>0,"GSpubli"])

targets[14] <- nrow(outsiders[outsiders$Oin==0,])/Odata #density at 0 for sons
targets[15]<- as.numeric(quantile(outsiders$Opubli,0.5)) #median for sons
targets[16]<- as.numeric(quantile(outsiders$Opubli,0.75)) # third quartile for sons
targets[17]<- as.numeric(quantile(outsiders$Opubli,0.95)) #upper tail for sons
targets[18]<-mean(outsiders$Opubli)

## in case we want to save the actual targets, not their mean
targ<-targ[0,] #delete all rows
targ[1,]<- targets
targets_mean<- apply(targ,2,mean) 
print("mean of actual targets")
print(round(targets,3))

sink()


saveRDS(targets_mean, "targets_mean.rds")
saveRDS(targets_se, "targets_se.rds")


pdf("QQ-plot-wikipedia.pdf", width = 8 , height = 8)


t1<-ks.test(outsiders$Opubli,families$Spubli)

qqplot(outsiders$Opubli,families$Spubli,xlab=paste("Outsiders' publications (n.obs=",nrow(outsiders),")",sep=""),
ylab="Sons' or Fathers' publications",
xlim=c(0,14),ylim=c(0,14), main=NULL,pch=2,col="firebrick2",cex=.6,lwd=2)
legend(0, 13, legend=paste("Sons, K-S = ",round(t1$statistic,3),
  " (",round(t1$p.value,3),")",sep=""), cex=0.9,pt.lwd=2,box.lty=0,pch=2,col="firebrick2")
abline(a=0,b=1)

par(new=TRUE)

t2<-ks.test(outsiders$Opubli,families$Fpubli)

qqplot(outsiders$Opubli,families$Fpubli,xlab=" ",ylab=" ",
xlim=c(0,14),ylim=c(0,14), main=NULL,pch=1,col="steelblue2",cex=.6,lwd=2)
legend(0, 12, legend=paste("Fathers, K-S = ",round(t2$statistic,3),
  " (",round(t2$p.value,3),")",sep=""), cex=.9,pt.lwd=2,box.lty=0,pch=1,col="steelblue3")
abline(a=0,b=1)

dev.off()
