
## remove (almost) everything in the working environment.
rm(list = ls())


# to import xl files
if(!require(readxl)) {install.packages("readxl"); require(readxl)} 


setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\database")


#load database of families
familiesb <- as.data.frame(read_excel("Families-publis.xlsx"))
Ndata<- nrow(familiesb)

gfamiliesb <- as.data.frame(read_excel("GFamilies-publis.xlsx"))

labels<- c("corr(F,S)","% S with 0","Q50 S","Q75 S","Q95 S","% F with 0",
"Q50 F","Q75 F","Q95 F","% S&F with 0","corr(GF,GS)")


#number of draws
set.seed(5) #Use the set.seed function when running simulations to ensure all results, figures, etc are reproducible.
ndraws<-10000
#list of targets
targets<-numeric(11)

targ <- data.frame(corrFS=numeric(),S0=numeric(),SQ50=numeric(),SQ75=numeric(),SQ95=numeric(),
F0=numeric(),FQ50=numeric(),FQ75=numeric(),FQ95=numeric(),SF0=numeric(),corrGFGS=numeric())

for (i in (1:ndraws)){

#draw new artifical sample
families <- familiesb[sample(1:Ndata,size=Ndata,replace=T),]

#build a new gfamilies from the artificial families
list_sons <- unique(families$Son)
list_fathers <- families[families$Father %in% list_sons,"Father"]
list_grandsons <-  families[families$Father %in% list_fathers,"Son"]
gfamilies <- data.frame("GrandFather"=character(),"GrandSon"=character(),"GFpubli"=numeric(),"GSpubli"=numeric(), 
                                 "GFin"=numeric(),"GSin"=numeric(),stringsAsFactors=FALSE)
ngfamil<-length(list_grandsons)
for (v in (1:ngfamil)){
grdson <- list_grandsons[v]
gfamilies[v,"GrandSon"]<-grdson
gfamilies[v,"GSpubli"]<-unique(families[families$Son==grdson,"Spubli"])
gfamilies[v,"GSin"]<-unique(families[families$Son==grdson,"Sin"])
son <- unique(families[families$Son==grdson,"Father"])
grdfather <- unique(families[families$Son==son,"Father"])
gfamilies[v,"GrandFather"]<-grdfather
gfamilies[v,"GFpubli"]<-unique(families[families$Father==grdfather,"Fpubli"])
gfamilies[v,"GFin"]<-unique(families[families$Father==grdfather,"Fin"])
}
gfamilies <- gfamilies[!(gfamilies$GrandFather %in% list_sons),]


#moments
targets[1] <-cor(families[!(families$Father %in% list_sons) & families$Fin>0 & families$Sin>0,"Fpubli"],
                               families[!(families$Father %in% list_sons) & families$Fin>0 & families$Sin>0,"Spubli"],method="spearman")
targets[2] <- nrow(families[families$Sin==0,])/Ndata #density at 0 for sons
targets[3]<- as.numeric(quantile(families$Spubli,0.5)) #median for sons
targets[4]<- as.numeric(quantile(families$Spubli,0.75)) # third quartile for sons
targets[5]<- as.numeric(quantile(families$Spubli,0.95)) #upper tail for sons
targets[6] <- nrow(families[!(families$Father %in% list_sons) & families$Fin==0,])/nrow(families[!(families$Father %in% list_sons),]) #same four moments for fathers
targets[7]<- as.numeric(quantile(families[!(families$Father %in% list_sons),"Fpubli"],0.5))
targets[8]<- as.numeric(quantile(families[!(families$Father %in% list_sons),"Fpubli"],0.75))
targets[9]<- as.numeric(quantile(families[!(families$Father %in% list_sons),"Fpubli"],0.95))
targets[10]<- nrow(families[families$Fin==0 & families$Sin==0,])/Ndata
targets[11] <- cor(gfamilies[gfamilies$GFin>0 & gfamilies$GSin>0,"GFpubli"],
                                 gfamilies[gfamilies$GFin>0 & gfamilies$GSin>0,"GSpubli"],method="spearman")

targ[i,]<- targets

}


targets_mean<- apply(targ,2,mean)
targets_se<- apply(targ,2,sd)



setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\robustness")
sink(file="sink se of moments rank.txt")

#printing mean and SE of moments

print("mean and SE of simulated targets")
print(round(targets_mean,3))
print(round(targets_se,4))

# printing actual moments
families <- familiesb
gfamilies <- gfamiliesb

#list of sons
list_sons <- unique(families$Son)

targets[1] <-cor(families[!(families$Father %in% list_sons) & families$Fin>0 & families$Sin>0,"Fpubli"],
                               families[!(families$Father %in% list_sons) & families$Fin>0 & families$Sin>0,"Spubli"],method="spearman")
targets[2] <- nrow(families[families$Sin==0,])/Ndata #density at 0 for sons
targets[3]<- as.numeric(quantile(families$Spubli,0.5)) #median for sons
targets[4]<- as.numeric(quantile(families$Spubli,0.75)) # third quartile for sons
targets[5]<- as.numeric(quantile(families$Spubli,0.95)) #upper tail for sons
targets[6] <- nrow(families[!(families$Father %in% list_sons) & families$Fin==0,])/nrow(families[!(families$Father %in% list_sons),]) #same four moments for fathers
targets[7]<- as.numeric(quantile(families[!(families$Father %in% list_sons),"Fpubli"],0.5))
targets[8]<- as.numeric(quantile(families[!(families$Father %in% list_sons),"Fpubli"],0.75))
targets[9]<- as.numeric(quantile(families[!(families$Father %in% list_sons),"Fpubli"],0.95))
targets[10]<- nrow(families[families$Fin==0 & families$Sin==0,])/Ndata
targets[11] <- cor(gfamilies[gfamilies$GFin>0 & gfamilies$GSin>0,"GFpubli"],
                                 gfamilies[gfamilies$GFin>0 & gfamilies$GSin>0,"GSpubli"],method="spearman")

## in case we want to save the actual targets, not their mean
targ<-targ[0,] #delete all rows
targ[1,]<- targets
targets_mean<- apply(targ,2,mean) 
print("mean of actual targets")
print(round(targets,3))

sink()


saveRDS(targets_mean, "targets_mean fat.rds")
saveRDS(targets_se, "targets_se fat.rds")


