#list of all programs used with their inputs and outputs

###############################################BUILDING DATABASE####################################################
setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\database")
source('1.database.R')
#reads "Families.xlsx", "Dictionary.xlsx", "Profs.xlsx", and "Institutions-All.xlsx" from \\UTHC social mobility\\base,
#sinks descriptive statistics into "moments.txt"
#saves  resulting data into "Families-publis.xlsx","GFamilies-publis.xlsx","Institutions with families.xlsx")

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\database")
source('2.database-bis.R')
#reads "Families.xlsx", "Dictionary.xlsx", "Profs.xlsx", and "Institutions-All.xlsx" from \\UTHC social mobility\\base,
#sinks descriptive statistics into "moments-bis.txt"
#saves  resulting data into "Families-publis-bis.xlsx", and "GFamilies-publis-bis.xlsx"

#the other programs in this directory make some plots and statistics, but are not needed for the estimations


###############################################ESTIMATION####################################################
#all estimations are done with:
#set.seed(7)
#DEoptim(obj,lower=c(.1,.1,.1,-2,0,0),upper=c(6,1,4,7,4,10),control=controlDE)
#(bounds on the parameters)
##############################parameters of the simulation ################
#X<-50000  #number of artificial households
#extra<-1000 # extra weight on the two extensive margins of publication
#controlDE=list(itermax = 2000,trace = 500) # number of interations
##############################parameters for computing SE ################
#X<-50000  #number of artificial households
#extra<-1000 # extra weight on the two extensive margins of publication
#controlDE=list(itermax = 500,trace = 500) # number of interations, 500 is good enough for bootstrapped samples
#nboot<-200 #number of artificial samples
#############################################################################################


setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\estimation")
source('1. estimating moments.R')
#reads "Families-publis.xlsx" and "GFamilies-publis.xlsx" from \\UTHC social mobility\\database,
#sinks the results into "sink se of moments.txt"
#and saves  means and standards deviations of moments into "targets_mean.rds" and "targets_se.rds"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\estimation")
source('1. estimating moments bis.R')
#reads "Families-publis-bis.xlsx" and "GFamilies-publis-bis.xlsx" from \\UTHC social mobility\\database,
#sinks the results into "sink se of moments bis.txt"
#and saves  means and standards deviations of moments into "targets_mean_bis.rds" and "targets_se_bis.rds"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\estimation")
source('2. estimation-benchmark.R')
#reads "targets_mean.rds" and "targets_se.rds"
#sinks the results into "sink-estimation benchmark.txt"
#sends simulated data to "simulated publi mod2.xlsx" and "simulated publi mod3.xlsx"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\estimation")
source('2. estimation-benchmark bis.R')
#reads "targets_mean_bis.rds" and "targets_se_bis.rds"
#sinks the results into "sink-estimation benchmark bis.txt"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\estimation")
source('3. estimating SE.R')
#reads "Families-publis.xlsx" from \\UTHC social mobility\\database,
#reads "targets_se.rds"
#sinks the results into "sink-estimation SE.txt"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\estimation")
source('3. estimating SE bis.R')
#reads "Families-publis-bis.xlsx" from \\UTHC social mobility\\database,
#reads  "targets_se_bis.rds"
#sinks the results into "sink-estimation SE bis.txt"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\estimation")
source('4. estimation by groups.R')
#reads "targets_mean.rds" and "targets_se.rds"
#sinks the results into "sink-estimation by group.txt"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\estimation")
source('5. SE by groups.R')
#reads "Families-publis.xlsx" from \\UTHC social mobility\\database,
#reads "targets_se.rds"
#sinks the results into "sink-SE estimation by group.txt"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\estimation")
source('6. QQ plot fit.R')
#reads "Families-publis.xlsx" from \\UTHC social mobility\\database,
#reads "simulated publi mod2.xlsx" and "simulated publi mod3.xlsx"
#produces "QQ-plot-fit.pdf"

###############################################ROBUSTNESS####################################################

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\robustness")
source('1. estimation-different kappa.R')
#reads "targets_mean.rds" and "targets_se.rds" from \\UTHC social mobility\\estimation,
#sinks the results into "sink-estimation kappa.txt"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\robustness")
source('2. estimating moments-nworks.R')
#reads "Families-publis.xlsx" and "GFamilies-publis.xlsx" from \\UTHC social mobility\\database,
#sinks the results into "sink se of moments nworks.txt"
#and saves  means and standards deviations of moments into "targets_mean_nworks.rds" and "targets_se_nworks.rds"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\robustness")
source('3. estimation-robust nworks.R')
#reads "targets_mean_nworks.rds" and "targets_se_nworks.rds"
#sinks the results into "sink-estimation robust nworks.txt"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\robustness")
source('4. estimating moments-pubby.R')
#reads "Families-publis.xlsx" and "GFamilies-publis.xlsx" from \\UTHC social mobility\\database,
#sinks the results into "sink se of moments pubby.txt"
#and saves  means and standards deviations of moments into "targets_mean_pubby.rds" and "targets_se_pubby.rds"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\robustness")
source('5. estimation-robust pubby.R')
#reads "targets_mean_pubby.rds" and "targets_se_pubby.rds"
#sinks the results into "sink-estimation robust pubby.txt"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\robustness")
source('6. estimating moments fat.R')
#reads "Families-publis.xlsx" and "GFamilies-publis.xlsx" from \\UTHC social mobility\\database,
#sinks the results into "sink se of moments rank.txt"
#and saves  means and standards deviations of moments into "targets_mean fat.rds" and "targets_se fat.rds"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\robustness")
source('7. estimation-benchmark fat.R')
#reads "targets_mean fat.rds" and "targets_se fat.rds"
#sinks the results into "sink-estimation benchmark fat.txt"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\robustness")
source('8. estimation-modII.R')
#reads "targets_mean fat.rds" and "targets_se fat.rds"
#sinks the results into "sink-estimation modII.txt"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\robustness")
source('9. estimation-modIII.R')
#reads "targets_mean fat.rds" and "targets_se fat.rds"
#sinks the results into "sink-estimation modelIII.txt"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\robustness")
source('10. estimating SE.R')
#reads "Families-publis.xlsx" from \\UTHC social mobility\\database,
#reads  "targets_se fat.rds"
#sinks the results into "sink-estimation SE.txt"

###############################################OUTSIDERS####################################################

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\outsiders")
source('1. estimating moments.R')
#reads "Families-publis.xlsx" from \\UTHC social mobility\\database,
#reads "Profs-wiki-all.xlsx" and "Profs.xlsx" from \\UTHC social mobility\\base,
#sinks the results into "sink se of moments.txt"
#and saves  means and standards deviations of moments into "targets_mean.rds" and "targets_se.rds"
# write "QQ-plot-wikipedia.pdf"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\outsiders")
source('2. estimation with outsiders.R')
#reads "targets_mean.rds" and "targets_se.rds"
#sinks the results into "sink-estimation outsiders.txt"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\outsiders")
source('3. SE with outsiders.R')
#reads "Families-publis.xlsx" from \\UTHC social mobility\\database,
#reads "Profs-wiki-all.xlsx" and "Profs.xlsx" from \\UTHC social mobility\\base,
#reads  "targets_se.rds"
#sinks the results into "sink-estimation SE1.txt" and "sink-estimation SE2.txt"


###############################################HIGH-LOW-GROWTH####################################################

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\high-low-growth")
source('1. building high-low fields.R')
#reads "Profs-wiki-all.xlsx", "Institutions-All.xlsx", "Profs.xlsx" from \\UTHC social mobility\\base
#plots "hpfilter.pdf", 'med by relig over time.pdf', 'theo by relig over time.pdf', 'law by relig over time.pdf'
#'sci by relig over time.pdf', 'hum by relig over time.pdf', 'app by relig over time.pdf', 'growth rates.pdf'
# writes "fields-over-time.xlsx"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\high-low-growth")
source('2. updating database g0.R')
#reads "Families-publis.xlsx" from \\UTHC social mobility\\database,
#reads "fields-over-time.xlsx" from "\\UTHC social mobility\\high-low-growth"
#writes "Families-publis high-low g0.xlsx"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\high-low-growth")
source('2. updating database g14.R')
#reads "Families-publis.xlsx" from \\UTHC social mobility\\database,
#reads "fields-over-time.xlsx" from "\\UTHC social mobility\\high-low-growth"
#writes "Families-publis high-low g14.xlsx"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\high-low-growth")
source('3. estimation by groups high-low g0.R')
# reads "targets_se.rds" from "\\UTHC social mobility\\estimation"
# reads "Families-publis high-low g0.xlsx"
#sends results to "sink-estimation by group high-low g0.txt"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\high-low-growth")
source('3. estimation by groups high-low g14.R')
# reads "targets_se.rds" from "\\UTHC social mobility\\estimation"
# reads "Families-publis high-low g0.xlsx"
#sends results to "sink-estimation by group high-low g14.txt"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\high-low-growth")
source('4. SE by groups high-low g0.R')
#reads "Families-publis high-low g0.xlsx"
#reads "targets_se.rds" from "\\UTHC social mobility\\estimation"
#sinks the results into "sink-SE estimation by group high-low g0.txt"

setwd("C:\\Users\\ddlc\\Documents\\Dropbox\\01. Research\\UTHC social mobility\\high-low-growth")
source('4. SE by groups high-low g14.R')
#reads "Families-publis high-low g14.xlsx"
#reads "targets_se.rds" from "\\UTHC social mobility\\estimation"
#sinks the results into "sink-SE estimation by group high-low g14.txt"


